stages:
  - test
  - build
  - deploy

# PHP UnitTest:
#   image: registry.gitlab.com/net.christianto/images/php-testing:8.1
#   stage: test
#   coverage: /^\s*Lines:\s*\d+.\d+\%/
#   variables:
#     XDEBUG_MODE: coverage
#   before_script:
#     - composer config --global gitlab-oauth.gitlab.com "${CI_JOB_TOKEN}"
#     - composer install --no-interaction --no-progress
#   script:
#     - composer run test -- --colors=never --log-junit report.xml --coverage-text --coverage-cobertura=coverage.cobertura.xml
#   artifacts:
#     reports:
#       coverage_report:
#         coverage_format: cobertura
#         path: coverage.cobertura.xml
#       junit: report.xml

JS Test:
  image: node:20-alpine
  stage: test
  rules:
    - if: '$CI_COMMIT_BRANCH == "production"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  before_script:
    - npm config set -- "${CI_API_V4_URL#http*:}/projects/:_authToken" "${CI_JOB_TOKEN}"
    - npm config set -- "${CI_API_V4_URL#http*:}/packages/npm/:_authToken" "${CI_JOB_TOKEN}"
    - npm config set -- "@${CI_PROJECT_ROOT_NAMESPACE}:registry" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/npm/"
    - yarn config set cache-folder .yarn
    - yarn install --no-progress
  script:
    - yarn test
  artifacts:
    paths:
      - public/build/
  cache:
    paths:
      - node_modules/
      - .yarn/

JS Build:
  image: node:20-alpine
  stage: build
  rules:
    - if: '$CI_COMMIT_BRANCH == "production"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  before_script:
    - npm config set -- "${CI_API_V4_URL#http*:}/projects/:_authToken" "${CI_JOB_TOKEN}"
    - npm config set -- "${CI_API_V4_URL#http*:}/packages/npm/:_authToken" "${CI_JOB_TOKEN}"
    - npm config set -- "@${CI_PROJECT_ROOT_NAMESPACE}:registry" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/npm/"
    - yarn config set cache-folder .yarn
    - yarn install --no-progress
  script:
    - yarn build
  artifacts:
    paths:
      - public/build/
  cache:
    paths:
      - node_modules/
      - .yarn/

PHP Build:
  image: registry.gitlab.com/net.christianto/images/php-testing:8.3
  stage: build
  rules:
    - if: '$CI_COMMIT_BRANCH == "production"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  before_script:
    - composer config --global gitlab-oauth.gitlab.com "${CI_JOB_TOKEN}"
  script:
    - composer install --no-dev --no-interaction --no-progress
  artifacts:
    paths:
      - vendor

Deploy:
  stage: deploy
  image: registry.gitlab.com/chez14/publisher:1.1.0
  rules:
    - if: '$CI_COMMIT_BRANCH == "production"'

    - if: '$CI_COMMIT_BRANCH == "production"'
      changes:
        - "database/migrations/**/*"
        - "database/seeders/**/*"
      when: manual

  needs:
    - job: "JS Build"
      artifacts: true
    - job: "PHP Build"
      artifacts: true
  before_script:
    - setup-ssh.sh
  script:
    - rsync -rzuchi
      -e "ssh -o StrictHostKeyChecking=no"
      --delete
      --exclude-from=.gitlab/rsync-exclude.txt
      ./
      $DEPLOY_DESTINATION
  environment:
    name: Production
    url: https://portmafia-api.christianto.net/
